void handleIr() {
  if(useInfrared) {
    bool ir = !digitalRead(pinInIr);
    if(ir && !currentlyReading && !modeChange && !beforeChange) {
      if(!impulseReading) {
        //erster Auslöser, Startzeit merken
        start = millis(); 
        impulseReading = true;
      } else if(millis() - start >= minIrImpulseInterval) {
        //Mindest-Auslösezeit erreicht, ersten Streifen erkannt
        impulseReading = false;
        currentlyReading = true;
        impulseCounter = 1;
        startBlack = false;
        black = false;
        codeFound = false;
      }
    }
    if(currentlyReading) { //erster Streifen wurde erkannt...
      //...es müssen noch mindestens zwei weitere Impulse kommen
      //bei jedem Lesen Mindest-Impulszeit berücksichtigen
      if(!ir && !startBlack && !black && (millis() - start >= minIrImpulseInterval)) {
        //Start Schwarzphase
        startBlack = true;
        //Timer zurücksetzen
        start = millis();
      }
      if(!ir && startBlack && !black && (millis() - start >= minIrImpulseInterval)) {
        //Mindestlänge Schwarzphase erreicht
        startBlack = false;
        black = true;
      }
      if(ir && black) {
        //Start Weißphase, schwarz hatte Mindestlänge erreicht
        startWhite = true;
        black = false;
        start = millis();
      }
      if(ir && startWhite && (millis() - start >= minIrImpulseInterval)) {
        impulseCounter ++;
        startWhite = false;
      }
      if(impulseCounter >= 3) codeFound = true;
      //nach bestimmter Zeit nach letztem Impuls abbrechen (breakIrReadAfter)
      if(millis() - start > breakIrReadAfter) {
        currentlyReading = false;
        if(codeFound) barcodeAction(); //Aktion initialisieren
      }
    }
  }
}

void barcodeAction() {
  //wenn Code erkannt, LEDs kurz flashen
  flashLeds();
  switch(impulseCounter) {
    case 3:
      //drei Streifen = nicht lenken für Zeitraum x
      delayLaneChange(delayLaneChangeDuration);
      break;
    case 4:
      //vier Streifen = sofort lenken
      //ggfs. laufenden Spurwechsel abbrechen bzw. nach hinten verschieben
      delayLaneChange(delayLaneChangeDuration);
      wheelState = !wheelState;
      initLaneChange(wheelState);
      break;
    case 5:
      //fünf Streifen = Leerlauf für Zeitraum x
      idleOn = true;
      previousIdleMillis = millis();
      delayLaneChange(idleDuration);
      break;
    default:
      //Streifen > 5 = Turbo, für jeden weiteren Streifen eine halbe Sekunde zur Dauer hinzu
      turboDuration = (impulseCounter - 5) * 500;
      turboOn = true;
      previousTurboMillis = millis();
      delayLaneChange(turboDuration);
  }
}

