void handleCollision() {
  bool collision = digitalRead(pinInCollision);
  if(modeCollision) {
    //wenn schon im Kollisionsmodus:
    //warten, bis Schalter wieder gelöst
    if(!collision && (millis() - switchMillis > bounceTimeRelease)) { //Schalter gelöst, Prellzeit berücksichtigen
      if(!modeWait && !modeChange) {
        //Wartemodus aktivieren
        modeWait = true;
        previousCollisionMillis = millis();
      }
      if(modeWait) {
        //zwei Sekunden warten
        unsigned long collisionMillis = millis();
        if(collisionMillis - previousCollisionMillis > collisionWait) {
          previousCollisionMillis = collisionMillis;
          modeCollision = false;
          modeWait = false;
          modeChange = true;
          hazard = false;
          ledsOff();
          /*digitalWrite(pinOutLedTurnLeft, LOW); //Hack, aber ledsOff würde sofort den neu gesetzten Blinker wieder zurücksetzen
          digitalWrite(pinOutLedTurnRight, LOW);
          turnLeft = false;
          turnRight = false;*/
          //ledsOff = true;
          //Spurwechsel initiieren, anfahren
          currentSpeed = afterCollisionSpeed;
          wheelState = !wheelState;
          //JETZT SOFORT wechseln
          initLaneChange(wheelState);
        }
      }
    }
  } else if(collision) {
    if(millis() - previousCollisionPressMillis > bounceTimePress) { //Taster mindestens x Millisekunden ausgelöst
      //Neue Kollision
      modeCollision = true;
      //Motor aus, Warnblinker
      currentSpeed = 0;
      hazard = true;
      //Spurwechsel unterbrechen, falls gerade
      changePlanned = false; modeChange = false; beforeChange = false;
      //Prellzeit für Taster
      switchMillis = millis();
      previousCollisionPressMillis = 0;
    } else {
      //erster Aufruf
      if(previousCollisionPressMillis == 0) previousCollisionPressMillis = millis();
    }
  }
}

