void laneChange() {
  if(modeChange) {
    //Spurwechsel bereits initiiert, Blinker noch zwei Sekunden laufen lassen
    unsigned long laneChangeMillis = millis();
    if(laneChangeMillis - previousChangeMillis > signalAfterWait) {
      previousChangeMillis = laneChangeMillis;
      modeChange = false;
      ledsOff();
      //ledsOff = true;
      changePlanned = false;
    }
  } else if(!modeCollision) {
    //nächsten Spurwechsel festlegen
    if(!changePlanned) {
      laneChangeTime = millis() + random(laneChangeMin, laneChangeMax);
      changePlanned = true;
    } else {
      unsigned long laneChangeMillis = millis();
      if(laneChangeMillis >= laneChangeTime) {
        //Die Zeit ist reif - Spurwechsel initiieren
        if(!beforeChange) {
          previousChangeMillis = laneChangeMillis;
          beforeChange = true;
          wheelState = !wheelState;
          //vorblinken
          if(wheelState) turnLeft = true; else turnRight = true;
        } else {
          if(laneChangeMillis - previousChangeMillis > signalBeforeWait) {
            //vorblinken ist vorbei - JETZT wechseln
            initLaneChange(wheelState);
          }
        }
      }        
    }
  }
}

void initLaneChange(bool wheelDirection) {
  if(wheelDirection) turnLeft = true; else turnRight = true;
  previousChangeMillis = millis();
  beforeChange = false;
  modeChange = true;
  currentWheelState = wheelDirection;
  //driveMotor(currentSpeed, currentWheelState);  
}

void delayLaneChange(int delayTime) {
  //laufenden Spurwechsel abbrechen
  /*if(beforeChange || modeChange) {
    beforeChange = false;
    modeChange = false;
    ledsOff();
    changePlanned = false;
  }*/
  //nächsten geplanten Spurwechsel nach hinten verschieben,
  //falls dieser in den Zeitraum fällt
  if(laneChangeTime <= (millis() + delayTime)) {
    laneChangeTime += delayTime;
  }  
}
